﻿/*
 * Author: G. Monz (DK7IO), 2012-04-29
 * This file is distributed without any warranty.
 * */

using System;
using System.IO;

namespace RadioMobile
{
	public class RMSystem
	{
		Single _transmitPower = (Single)(10);
		public Single TransmitPower //Watt
		{
			get
			{
				return _transmitPower;
			}
			set
			{
				_transmitPower = value;
			}
		}

		Single _receiverThreshold = (Single)(-107);
		public Single ReceiverThreshold //dBm
		{
			get
			{
				return _receiverThreshold;
			}
			set
			{
				_receiverThreshold = value;
			}
		}

		Single _lineLoss = (Single)(0.5);
		public Single LineLoss //dB
		{
			get
			{
				return _lineLoss;
			}
			set
			{
				_lineLoss = value;
			}
		}

		Single _antennaGain = (Single)(2);
		public Single AntennaGain //dBi
		{
			get
			{
				return _antennaGain;
			}
			set
			{
				_antennaGain = value;
			}
		}

		Single _antennaHeight = (Single)(2);
		public Single AntennaHeight //m
		{
			get
			{
				return _antennaHeight;
			}
			set
			{
				_antennaHeight = value;
			}
		}

		String _name = "System   1";
		public String Name //Length:=30
		{
			get
			{
				return _name;
			}
			set
			{
				_name = value;
			}
		}

		public RMSystem()
		{
		}

		public RMSystem(string name)
			: this()
		{
			Name = name;
		}

		public void Save(BinaryWriter binaryWriter)
		{
			binaryWriter.Write(TransmitPower);
			binaryWriter.Write(ReceiverThreshold);
			binaryWriter.Write(LineLoss);
			binaryWriter.Write(AntennaGain);
			binaryWriter.Write(AntennaHeight);
			binaryWriter.Write((Utilities.PadRight(Name, 30, true)));
		}
	}
}