﻿/*
 * Author: G. Monz (DK7IO), 2012-04-29
 * This file is distributed without any warranty.
 * */

using System;
using System.IO;

namespace RadioMobile
{
	public class RM_NetFile3000 : RM_NetFile
	{
		public const Single NetVersion = (Single)(3000);

		public RM_NetFile3000()
			: base()
		{
		}

		public override void Save(string fileName)
		{
			Stream stream = new FileStream(fileName, FileMode.Create, FileAccess.Write);
			{
				BinaryWriter binaryWriter = new VB6BinaryWriter(stream);
				{
					binaryWriter.Write(NetVersion);

					binaryWriter.Write((Int16)Nets.Count);

					binaryWriter.Write((Int16)Units.Count);

					binaryWriter.Write((Int16)Systems.Count);

					foreach (RMUnit item in Units)
					{
						item.Save(binaryWriter);
					}

					foreach (RMSystem item in Systems)
					{
						item.Save(binaryWriter);
					}

					for (int i = 0; i < NetRoles.GetLength(0); i++)
					{
						for (int j = 0; j < NetRoles.GetLength(1); j++)
						{
							binaryWriter.Write(NetRoles[i, j]);
						}
					}

					for (int i = 0; i < NetSystems.GetLength(0); i++)
					{
						for (int j = 0; j < NetSystems.GetLength(1); j++)
						{
							binaryWriter.Write(NetSystems[i, j]);
						}
					}

					foreach (RMNet item in Nets)
					{
						item.Save(binaryWriter);
					}

					Coverage.Save(binaryWriter);

					{
						String mapFile = "default.map";
						binaryWriter.Write((Int16)mapFile.Length);
						binaryWriter.Write(mapFile);
					}

					{
						String picture = "picture1.bmp";
						binaryWriter.Write((Int16)picture.Length);
						binaryWriter.Write(picture);
					}

					{
						String picture = "picture2.bmp";
						binaryWriter.Write((Int16)picture.Length);
						binaryWriter.Write(picture);
					}

					binaryWriter.Write((Int16)0);

					for (int i = 0; i < NetAntennaHeights.GetLength(0); i++)
					{
						for (int j = 0; j < NetAntennaHeights.GetLength(1); j++)
						{
							binaryWriter.Write(NetAntennaHeights[i, j]);
						}
					}

					for (int i = 0; i < UnitIcons.GetLength(0); i++)
					{
						binaryWriter.Write(UnitIcons[i]);
					}

					for (int i = 0; i < AdditionalCableLossesPerMeter.GetLength(0); i++)
					{
						binaryWriter.Write(AdditionalCableLossesPerMeter[i]);
					}
				}
				binaryWriter.Close();
			}
			stream.Close();
		}
	}
}